﻿using System.ComponentModel;
using System.Runtime.CompilerServices;
using WpfInfragistics18Experiments.Annotations;

namespace WpfInfragistics18Experiments
{
    public class ObservableModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}